<template>
	<div>
		<v-snackbar v-model="snack" top color="blue">Puntaje actualizado</v-snackbar>
		<v-dialog v-model="visibleForm" persistent max-width="550">
			<v-card>
				<v-toolbar>
					<v-toolbar-title>Carreras de {{ institute }}</v-toolbar-title>
					<v-spacer></v-spacer>
					<v-toolbar-items>
						<v-btn text icon color="red" @click="closeModalCareers">
							<v-icon>fas fa-times</v-icon>
						</v-btn>
					</v-toolbar-items>
				</v-toolbar>
				<v-card-text>
					<v-data-table :headers="headers" :items="careers">
						<template v-slot:item.action="{ item }">
							<v-tooltip bottom>
								<template v-slot:activator="{ on }">
									<v-btn text icon color="success" v-on="on" @click="openUpdate(item)">
										<v-icon>fas fa-edit</v-icon>
									</v-btn>
								</template>
								<span>Actualizar puntaje</span>
							</v-tooltip>
							<v-tooltip bottom>
								<template v-slot:activator="{ on }">
									<v-btn text icon color="purple" v-on="on" @click="openChangeName(item.key)">
										<v-icon>fas fa-pencil-alt</v-icon>
									</v-btn>
								</template>
								<span>Cambiar nombre</span>
							</v-tooltip>
							<v-tooltip bottom>
								<template v-slot:activator="{ on }">
									<v-btn text icon color="red" v-on="on" @click="openDeleteCareer(item.key)">
										<v-icon>fas fa-trash-alt</v-icon>
									</v-btn>
								</template>
								<span>Eliminar carrera</span>
							</v-tooltip>
						</template>
					</v-data-table>
				</v-card-text>
			</v-card>
		</v-dialog>
		<ModalUpdateScoreCareer :visible="visibleScore" :institute="institute" :name="nameCareer" :valor="valueCareer"/>
		<ModalChangeNameCareer :visible="visibleChangeName" :nameCareer="nameCareer" :institute="institute"/>
		<ModalConfirmDeleteCareer :visible="visibleDeleteCareer" :career="nameCareer" :institute="institute"/>
	</div>
</template>

<script>
import EventBus from "../../bus";
import gql from "graphql-tag";
import ModalUpdateScoreCareer from "@/components/admin/ModalUpdateScoreCareer";
import ModalChangeNameCareer from "@/components/admin/ModalChangeNameCareer";
import ModalConfirmDeleteCareer from "@/components/admin/ModalConfirmDeleteCareer";
import { mapActions } from 'vuex';

export default {
	name: "ModalCareers",
	components: { ModalUpdateScoreCareer, ModalChangeNameCareer, ModalConfirmDeleteCareer },
	props: ["visibleForm", "institute", "careers"],
	data: () => ({
		snack: false,
		visibleScore: false,
		nameCareer: "",
		valueCareer: 0,
		headers: [
			{ text: "Carrera", value: "key" },
			{ text: "Puntaje", value: "value", align:"center"},
			{ text: "Acciones", value: "action", align:"center" }
		],
		visibleChangeName: false,
		nameCareer:"",
		visibleDeleteCareer: false,

	}),
	methods: {
		...mapActions(["deleteCareer"]),

		closeModalCareers() {
			EventBus.$emit("closeModalCareers");
		},
		openUpdate(career){
			this.visibleScore = true;
			this.nameCareer = career.key;
			this.valueCareer = career.value;
		},
		openChangeName(name){
			this.nameCareer = name;
			this.visibleChangeName = true;
		},
		openDeleteCareer(name){
			this.nameCareer = name;
			this.visibleDeleteCareer = true;
		}
	},
	mounted() {
		EventBus.$on("closeUpdateScoreCareer",() => {
			this.visibleScore = false;
		});

		EventBus.$on("closeChangeNameCareer",() => {
			this.visibleChangeName = false;
		});

		EventBus.$on("succChangeNameCareer",() => {
			this.visibleChangeName = false;
		});

		EventBus.$on("closeConfirmDeleteCareer",() => {
			this.visibleDeleteCareer = false;
		});

		EventBus.$on("confirmDeleteCareer",(data) => {
			this.deleteCareer(data);
			this.visibleDeleteCareer = false;
		});
	}
};
</script>